<template>
    <div class="tab">
        <div class="tab-header">
            <div v-for="(tab, index) in tabs"
                 :key='tab.title'
                 :class="{'active': (index == activeTab)}"
                 @click="switchTab(index, tab.name)">
                {{ tab.title }}
            </div>
        </div>
        <slot></slot>
    </div>
</template>

<script>
export default {
    name: 'tabs-component',
    props: {},
    data() {
        return {
            activeTab: 0,
            tabs: []
        }
    },
    created() {
        this.tabs = this.$children
    },
    mounted() {
        this.switchTab(0, this.tabs[0].name)
    },
    methods: {
        switchTab(tabIndex, name) {
            this.$emit('change', name);
            this.activeTab = tabIndex;

            // loop over all the tabs
            this.tabs.forEach((tab, index) => {
                tab.isActive = (index === tabIndex)
            })
        }
    }
}
</script>

<style lang="scss">
@import "../../assets/styles/base/_tabs";
</style>
